#ifdef __USAGE		/* Prtsc.c */
%C	<console_device >file
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/dev.h>
#include <sys/kernel.h>
#include <fcntl.h>
#include <sys/console.h>
#include <unistd.h>


main( int argc, char *argv[] )
	{
	struct	_console_ctrl *cc;
	short		*buf;
	short		rows, cols;
	short		*p, row, col, end;


	if ( !( cc = console_open( 0, O_RDWR ) ) ) {
		exit( EXIT_FAILURE );
		}

	/*
	 * Get screen size into (rows, cols)
	 */
	console_size( cc, 0, 0, 0, &rows, &cols );

	/*
	 * Allocate a buffer big enough to hold entire screen
	 */
	if ( !( buf = malloc( rows * cols * 2 ) ) ) {
		console_close( cc );
		exit( EXIT_FAILURE );
		}

	console_read( cc, 0, 0, (char *) buf, rows*cols*2, 0, 0, 0 );

	for( row = 0; row < rows; ++row ) {
		p = buf + (row * cols);
		end = cols - 1;
		while(end >= 0  &&  (*(p + end) & 0xff) == ' ')
			--end;
		for( col = 0; col <= end; ++col ) {
			putc( *p++ & 0xff, stdout );
			}
		putc( '\n', stdout );
		}

	console_close( cc );
	exit( EXIT_SUCCESS );
	}
